%include "nagoa+.inc"

%include "gl.inc"            ;; converted from gl.h using h2inc.exe...

;%macro API 2                                   ;Function , Library
;	import %1 %2
;	extern %1
;%endmacro

API GetModuleHandleA, kernel32.dll
API RegisterClassExA, user32.dll
API LoadIconA,user32.dll
API CreateWindowExA, user32.dll
API MessageBoxA, user32.dll
API SendMessageA, user32.dll
API DefWindowProcA, user32.dll
API ExitProcess, kernel32.dll
API GetMessageA, user32.dll
API DispatchMessageA, user32.dll
API TranslateMessage,user32.dll
API ShowWindow,user32.dll
API UpdateWindow,user32.dll
API PostQuitMessage,user32.dll
API LoadCursorA,user32.dll
API PeekMessageA,user32.dll


API GetClientRect,user32.dll
API InvalidateRect,user32.dll


API GetDC,user32.dll

API GetStockObject,gdi32.dll
API ChoosePixelFormat,gdi32.dll
API SetPixelFormat,gdi32.dll
API wglCreateContext,opengl32.dll
API wglMakeCurrent,opengl32.dll
API wglDeleteContext,opengl32.dll
API glClearColor,opengl32.dll
API glClear,opengl32.dll
API glPushMatrix,opengl32.dll
API glPopMatrix ,opengl32.dll
API glRotatef,opengl32.dll
API glBegin,opengl32.dll
API glEnd,opengl32.dll
API glColor3f,opengl32.dll
API glVertex2f,opengl32.dll
API glViewport,opengl32.dll
API SwapBuffers,gdi32.dll

API ReleaseDC,user32.dll

segment .data USE32

Windowname db 'Opengl example.',0
Windowhandle	dd 0
Instance	dd 0
Windowclassname db "OurWindowclass",0


fzero 	dd 	 0.0e0		;; help needed to use floating pt. constants directly in call macro..
fone 	dd 	 1.0e0		;; 
fmdot87 dd 	-0.87e0
fdot87 	dd 	 0.87e0
fmdot5 	dd 	-0.5e0

OurWindowclass:	
istruc WNDCLASSEX
	at WNDCLASSEX.cbSize,		dd WNDCLASSEX_size
	at WNDCLASSEX.style,		dd CS_OWNDC|CS_HREDRAW|CS_VREDRAW
	at WNDCLASSEX.lpfnWndProc,	dd WindowProc
	at WNDCLASSEX.hbrBackground,	dd 0
	at WNDCLASSEX.lpszMenuName,	dd 0
	at WNDCLASSEX.lpszClassName,	dd Windowclassname
iend

hDC	dd	0
hRC	dd	0
theta 	dd 	1.0e0



segment .bss USE32
itm1 resb 32
MessageBuffer resb MSG_size
rc resb RECT_size


segment .code USE32

..start:

call GetModuleHandleA, 0
mov dword [Instance], eax

loccall WinMain, [Instance]

getout:
call ExitProcess, eax



proc WinMain, hInstance
	mov eax, dword [@hInstance]
	mov dword [OurWindowclass+WNDCLASSEX.hInstance], eax
	call LoadIconA, NULL, IDI_APPLICATION
	mov dword [OurWindowclass+WNDCLASSEX.hIcon], eax
	mov dword [OurWindowclass+WNDCLASSEX.hIconSm], eax
	call GetStockObject,BLACK_BRUSH
	mov dword [OurWindowclass+WNDCLASSEX.hbrBackground], eax
	
	call RegisterClassExA,OurWindowclass
	if eax,e,0
		return
	endif
	
	;--- create and show the main program window
	call CreateWindowExA,NULL,Windowclassname,Windowname,WS_VISIBLE+WS_OVERLAPPEDWINDOW+WS_CLIPCHILDREN+WS_CLIPSIBLINGS,0,0,512,512, NULL, NULL, [@hInstance], NULL
	mov dword [Windowhandle], eax
	call ShowWindow, [Windowhandle],SW_SHOW
	call UpdateWindow,[Windowhandle]
	
	loccall EnableOpenGL
	
	; -- every time user moves mouse or imput some msg this loop is activated
	; -- in order to get all messages imputed by the user 
	messloop:
		
		call PeekMessageA,MessageBuffer, NULL, 0, 0,PM_REMOVE      
		if eax,ne,0
			if eax,b,0
				jmp near erro
			endif
			if dword[MessageBuffer+MSG.message],e,WM_QUIT
				jmp near finish
			else
				call TranslateMessage,MessageBuffer
				call DispatchMessageA,MessageBuffer
			endif
		else
			loccall DrawScene
		endif
	jmp near messloop
	
	erro:
		call MessageBoxA, 0, "ERROR", "Sorry ...", MB_OK
	finish:
		loccall DisableOpenGL
		mov eax, dword[MessageBuffer+MSG.wParam]
endproc

proc WindowProc,hwnd,uMsg,wParam,lParam
	
	if dword[@uMsg],e,WM_CLOSE
		call PostQuitMessage, 0	
		xor eax,eax
	endif
	
	if dword[@uMsg],e,WM_DESTROY
		call PostQuitMessage, 0	
		xor eax,eax
	endif
	if dword[@uMsg],e,WM_SIZE
		call GetClientRect,[@hwnd],rc
		call glViewport,0,0,[rc+RECT.right],[rc+RECT.bottom]
		call InvalidateRect,[@hwnd],NULL,FALSE
	endif
	if dword[@uMsg],e,WM_KEYDOWN
		if dword[@wParam],e,VK_ESCAPE
			call PostQuitMessage, 0	
			xor eax,eax
		endif
	endif

defaultaction:
	call DefWindowProcA, [@hwnd], [@uMsg], [@wParam], [@lParam]
	return
endproc


proc EnableOpenGL
	stack pfd,PIXELFORMATDESCRIPTOR_size
	stack format,4
	
	call GetDC,[Windowhandle]
	mov [hDC],eax
	
	mov word[@pfd+PIXELFORMATDESCRIPTOR.nSize],PIXELFORMATDESCRIPTOR_size
	mov word[@pfd+PIXELFORMATDESCRIPTOR.nVersion],1
	mov dword[@pfd+PIXELFORMATDESCRIPTOR.dwFlags ], PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER
	mov byte[@pfd+PIXELFORMATDESCRIPTOR.iPixelType], PFD_TYPE_RGBA
	mov byte[@pfd+PIXELFORMATDESCRIPTOR.cColorBits], 24
	mov byte[@pfd+PIXELFORMATDESCRIPTOR.cDepthBits], 16
	mov byte[@pfd+PIXELFORMATDESCRIPTOR.iLayerType], PFD_MAIN_PLANE
	
	call ChoosePixelFormat,[hDC],ADDR @pfd
	mov [@format],eax
	call SetPixelFormat,[hDC],[@format],ADDR @pfd
	
	call wglCreateContext, [hDC]
	mov [hRC],eax
	call wglMakeCurrent, [hDC],[hRC]
endproc


proc DisableOpenGL
	call wglMakeCurrent,NULL,NULL 
	call wglDeleteContext,[hRC]
	call ReleaseDC,[Windowhandle],[hDC]
endproc


proc DrawScene

	call glClearColor,[fzero],[fzero],[fzero],[fzero]
	call glClear,GL_COLOR_BUFFER_BIT
	call glPushMatrix
	call glRotatef,[theta],[fzero],[fzero],[fone]

	call glBegin, GL_TRIANGLES 
	call glColor3f, [fone], [fzero],[fzero]
	call glVertex2f, [fzero], [fone]
	call glColor3f, [fzero], [fone],[fzero]
	call glVertex2f, [fdot87], [fmdot5]
	call glColor3f, [fzero], [fzero], [fone] 
	call glVertex2f,[fmdot87], [fmdot5]
	call glEnd

	call glPopMatrix
	call SwapBuffers,[hDC]

	fld dword[theta]              ;; theta = theta + 0.5f
	fadd dword[fmdot5]
	fstp dword[theta]
	
endproc